routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

    Route::get('/','FrontendController@frontendfun')->name('homepage');
    Route::get('register','LoginController@register')->name('register');
    Route::get('login','LoginController@login')->name('login');
    Route::post('save','LoginController@save')->name('save');
    Route::post('check','LoginController@check')->name('check');
    Route::get('home','FrontendController@frontendfun')->name('homepage');
    Route::post('logout','LoginController@logout')->name('logout');

    
    Route::middleware('can:only_admin')->group(function () {

        Route::get('dashboard','BackendController@dashboardfun')->name('dashboardpage');
        Route::get('search','SearchController@search')->name('search');
        Route::resource('product','ProductController');
        Route::get('userlist','LoginController@userlist')->name('userlist');
        Route::delete('userdelete/{id}','LoginController@userdelete')->name('userdelete');
        Route::get('useredit/{id}','LoginController@useredit')->name('useredit');
        Route::put('useredit/{id}','LoginController@userupdate')->name('userupdate');
    });   

app/Product.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Product extends Model
{
    protected $fillable = [
        'name', 'photo','description','price',
      ];
}

app/Http/Controllers/BackendController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class BackendController extends Controller
{
    public function dashboardfun(){
        return view('backend.dashboard');
    }
}

app/Http/Controllers/ProductController.php
<?php

namespace App\Http\Controllers;

use App\Product;
use Illuminate\Http\Request;

class ProductController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $products = Product::all();
        return view('backend.Product.index',compact('products'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('backend.Product.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $request->validate([
            'name' => 'required',
            'description' => 'required',
            'price' => 'required',
            'photo' => 'required',
        ]);
        $imageName = time().'.'.$request->photo->extension();

        $request->photo->move(public_path('backend/productimg'),$imageName);

        $path = 'backend/productimg/'.$imageName;
        // Data insert

        $product = new Product;
        $product->name = $request->name;
        $product->description = $request->description;
        $product->price = $request->price;
        $product->photo = $path;

        $product->save();
        return redirect()->route('product.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function show(Product $product)
    {
        $productdetail = Product::find($product->id);
        return view('backend.Product.detail',compact('productdetail'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function edit(Product $product)
    {
        return view('backend.Product.edit',compact('product'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Product $product)
    {
        
        $request->validate([
            'name' => 'required',
            'description' => 'required',
            'price' => 'required',
        ]);
       
        if($request->hasFile('photo')){
            $imageName = time().'.'.$request->photo->extension();
    
            $request->photo->move(public_path('backend/productimg'),$imageName);
    
            $path = 'backend/productimg/'.$imageName;
            }else{
                $path=$request->oldphoto;
            }
        // Data insert

        $product->name = $request->name;
        $product->description = $request->description;
        $product->price = $request->price;
        $product->photo = $path;

        $product->save();
        return redirect()->route('product.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function destroy(Product $product)
    {
        $product->delete();
        return redirect()->route('product.index');
    }

   
}

resources/views/backend/Product/create.blade.php
@extends('backendtemplate')

@section('content')
	<div class="container-fluid">
    <!-- Page Heading -->
    <div class="d-sm-flex align-items-center justify-content-between mb-4">
    	<div class="row">
    		<div class="col">
      		<h1 class="h3 mb-0 text-gray-800">Product Create Form</h1>
    		</div>
    	</div>
    </div>
    
    <div class="container">
      <div class="row">
      	<div class="col-md-12">
      		<form action="{{route('product.store')}}" method="post" enctype="multipart/form-data">
			      @csrf
			      
			       
                  <div class="form-group row {{ $errors->has('name') ? 'has-error' : '' }}">
			        <label for="inputName" class="col-sm-2 col-form-label">Name</label>
			        <div class="col-sm-5">
			          <input type="text" class="form-control" id="inputName" name="name">
			          <span class="text-danger">{{ $errors->first('name') }}</span>
			        </div>
			      </div>

                  <div class="form-group row {{ $errors->has('description') ? 'has-error' : '' }}">
			        <label for="inputName" class="col-sm-2 col-form-label">Description</label>
			        <div class="col-sm-5">
			          <input type="text" class="form-control" id="inputName" name="description">
			          <span class="text-danger">{{ $errors->first('description') }}</span>
			        </div>
			      </div>

                  <div class="form-group row {{ $errors->has('price') ? 'has-error' : '' }}">
			        <label for="inputName" class="col-sm-2 col-form-label">Price</label>
			        <div class="col-sm-5">
			          <input type="text" class="form-control" id="inputName" name="price">
			          <span class="text-danger">{{ $errors->first('price') }}</span>
			        </div>
			      </div>


			      <div class="form-group row {{ $errors->has('photo') ? 'has-error' : '' }}">
			        <label for="inputPhoto" class="col-sm-2 col-form-label">Photo</label>
			        <div class="col-sm-5">
			          <input type="file" id="inputPhoto" name="photo" class="d-block">
			          <span class="text-danger">{{ $errors->first('photo') }}</span>
			        </div>
			      </div>

			      <div class="form-group row">
			        <div class="col-sm-5">
			          <input type="submit" class="btn btn-primary" name="btnsubmit" value="Create">
			        </div>
			      </div>
			    </form>
      	</div>
      </div>
    </div>
 	</div>
@endsection

resources/views/backend/Product/detail.blade.php
@extends('backendtemplate')

@section('content')
	<div class="container-fluid">
    <!-- Page Heading -->
  	<div class="row">
  		<div class="col-md-12 mb-3">
    		<h1 class="h3 mb-0 text-gray-800 d-inline-block">Product Detail</h1>
  		</div>
  	</div>
    
    <div class="row">
    	<div class="col-md-6">
    		<img src="../{{$productdetail->photo}}" class="img-fluid img-thumbnail" >
    	</div>  
        <div class="col-md-6" style="margin-top:240px;">
    		<div class="text-center">{{$productdetail->name}}</div>
            <div class="text-center">{{$productdetail->description}}</div>
    		<div class="text-center">{{$productdetail->price}}</div>
    	</div>
    </div>

 	</div>
@endsection

resources/views/backend/Product/edit.blade.php
@extends('backendtemplate')

@section('content')
	<div class="container-fluid">
    <!-- Page Heading -->
    <div class="d-sm-flex align-items-center justify-content-between mb-4">
    	<div class="row">
    		<div class="col">
      		<h1 class="h3 mb-0 text-gray-800">Product Edit Form</h1>
    		</div>
    	</div>
    </div>
    
    <div class="container">
      <div class="row">
      	<div class="col-md-12">
      		<form action="{{route('product.update',$product->id)}}" method="post" enctype="multipart/form-data">
			      @csrf
			      @method('PUT')
			      
			       
			      <div class="form-group row {{ $errors->has('name') ? 'has-error' : '' }}">
			        <label for="inputName" class="col-sm-2 col-form-label">Name</label>
			        <div class="col-sm-5">
			          <input type="text" class="form-control" id="inputName" name="name" value="{{$product->name}}">
			          <span class="text-danger">{{ $errors->first('name') }}</span>
			        </div>
			      </div>

                  <div class="form-group row {{ $errors->has('description') ? 'has-error' : '' }}">
			        <label for="inputName" class="col-sm-2 col-form-label">Description</label>
			        <div class="col-sm-5">
			          <input type="text" class="form-control" id="inputName" name="description" value="{{$product->description}}">
			          <span class="text-danger">{{ $errors->first('description') }}</span>
			        </div>
			      </div>

                  <div class="form-group row {{ $errors->has('price') ? 'has-error' : '' }}">
			        <label for="inputName" class="col-sm-2 col-form-label">Price</label>
			        <div class="col-sm-5">
			          <input type="text" class="form-control" id="inputName" name="price" value="{{$product->price}}">
			          <span class="text-danger">{{ $errors->first('price') }}</span>
			        </div>
			      </div>

			        <label for="inputPhoto" class="col-sm-2 col-form-label">Photo</label>
			        <div class="col-sm-5">
			        	<nav>
						  <div class="nav nav-tabs" id="nav-tab" role="tablist">
						    <a class="nav-link active" id="nav-home-tab" data-toggle="tab" href="#nav-home" role="tab" aria-controls="nav-home" aria-selected="true">Old Photo</a>
						    <a class="nav-link" id="nav-profile-tab" data-toggle="tab" href="#nav-profile" role="tab" aria-controls="nav-profile" aria-selected="false">New Photo</a>
						    
						  </div>
						</nav>
						<div class="tab-content" id="nav-tabContent">
						  <div class="tab-pane fade show active" id="nav-home" role="tabpanel" aria-labelledby="nav-home-tab">
						  	<img src="{{asset($product->photo)}}" width="200px" height="150px" class="mt-3">
						  	<input type="hidden" name="oldphoto" value="{{$product->photo}}">
						  </div>
						  <div class="tab-pane fade" id="nav-profile" role="tabpanel" aria-labelledby="nav-profile-tab">
			          			<input type="file" id="inputPhoto" name="photo" class="d-block mt-3">
						  	
						  </div>
						 
						</div>


			        </div>

			      <div class="form-group row">
			        <div class="col-sm-5">
			          <input type="submit" class="btn btn-primary" name="btnsubmit" value="Update">
			        </div>
			      </div>
			    </form>
      	</div>
      </div>
    </div>
 	</div>
@endsection

resources/views/backend/Product/index.blade.php
@extends('backendtemplate')

@section('content')
	<div class="container-fluid">
    <!-- Page Heading -->
  	<div class="row">
  		<div class="col-md-12 mb-3">
    		<h1 class="h3 mb-0 text-gray-800 d-inline-block">Product List</h1>
    		<a href="{{route('product.create')}}" class="btn btn-info float-right"><i class="fas fa-plus"></i>Add New</a>
  		</div>
  	</div>
    
    <div class="row">
    	<div class="col-md-12">
    		<table class="table table-bordered">
    			<thead class="thead-dark">
    				<tr>
                        <th>No</th>
    					<th>Name</th>
                        <th>Photo</th>
                        <th>Description</th>
                        <th>Price</th>
                        <th>Action</th>
    				</tr>
    			</thead>
    			<tbody>
                @php $i=1; @endphp
                    @foreach($products as $product)
    				<tr>
                        <td>{{$i++}}</td>    
                        <td><a href="{{route('product.show',$product->id)}}">{{$product->name}}</a></td>            
                        <td><img src="{{$product->photo}}" class="rounded circle" width="150px" height="120px"></td>                  
                        <td>{{$product->description}}</td>            
                        <td>{{$product->price}}</td>            
                        <td>
                            
                            <a href="{{route('product.edit',$product->id)}}" class="btn btn-outline-warning"><i class="fas fa-edit"></i></a>

                            <form action="{{route('product.destroy',$product->id)}}" method="POST" class="d-inline-block">
                                @csrf
                                @method('DELETE')
                                <!-- delete lote yin method ka post nat ma ya buu dar kout method ko delete so pe change pay ya mal update lo myoe pot -->
                                <button class="btn btn-outline-danger "><i class="fas fa-trash"></i></button>
                            </form>
                        </td>            

                    </tr>
                    @endforeach
    			</tbody>
    		</table>
    	</div>
    </div>

 	</div>
@endsection